<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: MocoInverse: solving muscle and actuator redundancy</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('mocoinverse.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title"><a class="el" href="classOpenSim_1_1MocoInverse.html" title="This tool solves problems in which the kinematics are prescribed and you seek the actuator (e....">MocoInverse</a>: solving muscle and actuator redundancy </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>A common goal in musculoskeletal biomechanics is to estimate muscle and actuator behavior that drove an observed motion; this is often called the <b>muscle redundancy problem</b>.</p>
<p>We can solve this problem by tracking the observed motion, as with Computed Muscle Control (using the "slow target") or <a class="el" href="classOpenSim_1_1MocoTrack.html">MocoTrack</a>. Alternatively, we can prescribe the motion exactly, as with Static Optimization, EMG-driven simulation [1, 2], and the Muscle Redundancy Solver [3]. The advantage of prescribing the motion is the problem is more robust and solves faster, as the nonlinear multibody dynamics are no longer part of the optimization problem. The disadvantage is that we cannot predict deviations from the observed motion.</p>
<p>In Moco, you can use the <a class="el" href="classOpenSim_1_1MocoInverse.html" title="This tool solves problems in which the kinematics are prescribed and you seek the actuator (e....">MocoInverse</a> tool to solve optimization problems in which kinematics are known, including the muscle redundancy problem.</p>
<p>The <a class="el" href="classOpenSim_1_1MocoInverse.html" title="This tool solves problems in which the kinematics are prescribed and you seek the actuator (e....">MocoInverse</a> tool adds a <a class="el" href="classOpenSim_1_1PositionMotion.html" title="This class prescribes the value, speed, and acceleration of all coordinates in the model using SimTK:...">PositionMotion</a> component to your model, with splines created from a kinematics data file that you provide.</p>
<dl class="section note"><dt>Note</dt><dd>The kinematics you provide should already obey any kinematic constraints in your model. <a class="el" href="classOpenSim_1_1MocoInverse.html" title="This tool solves problems in which the kinematics are prescribed and you seek the actuator (e....">MocoInverse</a> attempts to alter your provided kinematics to satisfy the kinematic constraints (using Model::assemble()), so the tool will not actually track the kinematics as provided if they violate constraints.</dd></dl>
<p>Sometimes it is not possible to achieve the desired motion using muscles alone. There are multiple possible causes for this:</p><ul>
<li>the muscles are not strong enough to achieve the required net joint moments,</li>
<li>the net joint moments change more rapidly than activation and deactivation time constants allow,</li>
<li>the filtering of the data causes unrealistic desired net joint moments. For these reasons, you may want to add "reserve" actuators to your model. See <a class="el" href="classOpenSim_1_1ModelFactory.html#a89c02bc5d9722ca220edf8b169e45e30" title="Add CoordinateActuators for each unconstrained coordinate (e.g., ! Coordinate::isConstrained()) in th...">ModelFactory::createReserveActuators()</a> and <a class="el" href="classOpenSim_1_1ModOpAddReserves.html" title="Add reserve actuators to the model using ModelFactory::createReserveActuators.">ModOpAddReserves</a>.</li>
</ul>
<p>See <a class="el" href="mocostudy.html#preskin">Prescribed kinematics</a>, <a class="el" href="mocostudy.html#preskinconstr">Prescribed kinematics with kinematic constraints</a>, and <a class="el" href="mocodevguide.html#implpreskin">Prescribed kinematics</a> for more information.</p>
<p>[1] Arnold, E., Hamner, S., Seth, A., Millard, M., Delp, S. (2013). How muscle fiber lengths and velocities affect muscle force generation as humans walk and run at different speeds Journal of Experimental Biology 216(11), 2150-2160. <a href="https://dx.doi.org/10.1242/jeb.075697">https://dx.doi.org/10.1242/jeb.075697</a> <br  />
[2] Jackson, R., Dembia, C., Delp, S., Collins, S. (2017). Muscle-tendon mechanics explain unexpected effects of exoskeleton assistance on metabolic rate during walking Journal of Experimental Biology 220(11), jeb.150011. <a href="https://dx.doi.org/10.1242/jeb.150011">https://dx.doi.org/10.1242/jeb.150011</a> <br  />
[3] Groote, F., Kinney, A., Rao, A., Fregly, B. (2016). Evaluation of Direct Collocation Optimal <a class="el" href="classOpenSim_1_1Control.html" title="A class that represents a control in a dynamic simulation.">Control</a> Problem Formulations for Solving the <a class="el" href="classOpenSim_1_1Muscle.html" title="A base class for modeling a muscle-tendon actuator.">Muscle</a> Redundancy Problem Annals of Biomedical Engineering 44(10), 2922-2936. <a href="https://dx.doi.org/10.1007/s10439-016-1591-9">https://dx.doi.org/10.1007/s10439-016-1591-9</a> <br  />
</p>
</div></div><!-- contents -->
</div><!-- PageDoc -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="mocomainpage.html">Moco</a></li><li class="navelem"><a class="el" href="mocouserguide.html">Moco User Guide</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:40 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
